=== debian/changelog ===
scantailor (0.9.10-0ubuntu2) oneiric; urgency=low

  * Change to arch any (build for armel)
  * Add debian/patchs/qreal.diff to fix build on armel (qreal != double on
    armel)
  * Add libqt4-opengl-dev [amd64 i386 powerpc] to build-depends to build for
    GL on architectures that support it

 -- Scott Kitterman <scott@kitterman.com>  Sun, 07 Aug 2011 14:23:49 -0400

scantailor (0.9.10-0ubuntu1) oneiric; urgency=low

  * New upstream release.
  * Bump standards to 3.9.2
  * Build depend on libboost-test1.46-dev instead of libboost-test1.42-dev 

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 07 Aug 2011 22:06:50 +0530
