=== debian/watch ===
version=3

opts="uversionmangle=s/src-/0.0./" \
 http://sf.net/scantailor/scantailor-(.*)\.tar\.gz
