## scantailor 0.9.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,6 +70,7 @@
 
 INCLUDE(CheckIncludeFile)
 INCLUDE(CheckIncludeFileCXX)
+INCLUDE(TestCXXAcceptsFlag)
 INCLUDE(FindBoost)
 INCLUDE(cmake/FindPthreads.cmake)
 INCLUDE(cmake/SetDefaultBuildType.cmake)
@@ -408,10 +409,10 @@
 ADD_SUBDIRECTORY(zones)
 ADD_SUBDIRECTORY(tests)
 
-FILE(GLOB ui_files "ui/*.ui")
-SOURCE_GROUP("UI Files" FILES ${ui_files})
-QT4_WRAP_UI(ui_sources ${ui_files})
-SET_SOURCE_FILES_PROPERTIES(${ui_sources} PROPERTIES GENERATED TRUE)
-ADD_SUBDIRECTORY(ui)
-INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}") # for ui files
-
+FILE(GLOB common_ui_files ui/ErrorWidget.ui)
+FILE(GLOB gui_only_ui_files "ui/*.ui")
+FOREACH(ui_file ${common_ui_files})
+	LIST(REMOVE_ITEM gui_only_ui_files "${ui_file}")
+ENDFOREACH()
+
+SOURCE_GROUP("UI Files" FILES ${common_ui_files} ${gui_only_ui_files})
