=== crash_reporter/ui/CMakeLists.txt ===
SOURCE_GROUP("UI Files" FILES ${ui_files})
