=== debian/changelog ===
scantailor (0.9.11.1-4) unstable; urgency=medium

  * Added fix-qt4-parsing-error-on-libboost.patch (Closes: #798049)
  * deb/control: added libboost-dev to build-deps.

 -- Daniel Stender <debian@danielstender.com>  Wed, 07 Oct 2015 17:09:47 +0200

scantailor (0.9.11.1-3) unstable; urgency=medium

  * deb/control:
    + bumped standards to 3.9.6 (no changes needed).
    + updated Vcs-Browser.
  * deb/copyright: corrected typo, updated.
  * scantailor-cli.1: build with txt2man instead of Docbook,
    parsing date from changelog (Closes: #779339).
  * Added deb/gbp.conf.

 -- Daniel Stender <debian@danielstender.com>  Sat, 09 May 2015 09:24:55 +0200

scantailor (0.9.11.1-2) unstable; urgency=low

  * deb/control:
    + Bumped standards to 3.9.5 (no changes needed).
    + Maintainer email address and Homepage changed.
  * deb/copyright:
    + Upstream-Contact and Source changed.
    + Changed maintainer email address.
    + Expanded copyrights to 2014.
    + Removed unnecessary details.
  * deb/patches/series: added newline.
  * deb/scantailor.desktop: added Keywords.
  * Updated deb/watch file.

 -- Daniel Stender <debian@danielstender.com>  Wed, 02 Jul 2014 09:33:10 +0200

scantailor (0.9.11.1-1) unstable; urgency=low

  * Initial release (Closes: #523393, #538125).

 -- Daniel Stender <daniel@danielstender.com>  Mon, 24 Jun 2013 17:52:43 +0200
