=== debian/control ===
Source: scantailor
Section: graphics
Priority: optional
Maintainer: Daniel Stender <debian@danielstender.com>
Build-Depends:
 cmake,
 debhelper (>= 9),
 dpkg-dev (>= 1.16.1~),
 libboost-dev,
 libboost-test-dev,
 libjpeg-dev,
 libpng-dev,
 libqt4-dev,
 libqt4-opengl-dev,
 libtiff-dev,
 libxrender-dev,
 txt2man,
 xauth,
 xvfb
Standards-Version: 3.9.6
Homepage: http://scantailor.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/scantailor.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/scantailor.git

Package: scantailor
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: interactive post-processing tool for scanned pages
 Scan Tailor is an interactive post-processing tool for scanned pages. It
 performs operations such as page splitting, deskewing, adding/removing
 borders, and others. You give it raw scans, and you get pages ready to be
 printed or assembled into a PDF or DJVU file. Scanning, optical character
 recognition, and assembling multi-page documents are out of scope of this
 project.
