=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

VERSION := $(shell dpkg-parsechangelog -Sversion | cut -d- -f1)
DEBDATE := $(shell dpkg-parsechangelog -Sdate | date -u +"%F" -f -)

%:
	dh $@ --parallel

override_dh_auto_test:
	xvfb-run dh_auto_test

override_dh_install:
	dh_install
	install -d debian/scantailor/usr/share/pixmaps
	cp -a resources/appicon.svg debian/scantailor/usr/share/pixmaps/scantailor.svg

override_dh_installman:
	txt2man -s 1 -v "scantailor" -t "scantailor-cli" -r "$(VERSION)" \
	-d "$(DEBDATE)" debian/scantailor-cli.txt > debian/scantailor-cli.1
	dh_installman

override_dh_builddeb:
	dh_builddeb -- -Zxz
