=== debian/watch ===
version=3
opts=uversionmangle=s/_/\./g \
http://github.com/scantailor/scantailor/tags .*/RELEASE_([\d+_*]+)\.tar\.gz
